-
AI-powered Extensions
-
Data Grid
-
Tree List
-
Chat
-
HTML Editor
-
Form
-
-
Data Grids / Data Management
-
Data Grid
- Overview
-
Data Binding
-
Filtering
- Sorting
-
Editing
-
Grouping
-
Selection
- Focused Row
- Paging
-
Scrolling
-
Columns
- AI Assistant
-
Master-Detail
-
Data Summaries
-
Drag & Drop
-
Export to PDF
-
Export to Excel
- Appearance
-
Customization
- State Persistence
-
Adaptability
-
Keyboard Navigation
- Right-To-Left Support
-
Tree List
- Overview
-
Data Binding
-
Filtering
- Sorting
-
Editing
-
Selection
- Focused Row
- Paging
-
Columns
- Drag & Drop
- State Persistence
- Adaptability
-
Keyboard Navigation
-
Card View
-
Pivot Grid
- Overview
-
Data Binding
-
Field Management
-
Data Summaries
- Drill Down
- Filtering
-
Scrolling
-
Export to Excel
- Chart Integration
- Customization
- State Persistence
-
Filter Builder
-
-
Data Visualization
-
Charts
- Overview
-
Data Binding
-
Common Concepts
-
Axis
-
Aggregation
-
Tooltips
-
Selection
-
Customization
-
Zooming
-
Export
-
-
Area Charts
-
Bar Charts
- Bullet Charts
-
Doughnut Charts
-
Financial Charts
-
Funnel and Pyramid Charts
-
Line Charts
- Pareto Chart
-
Pie Charts
-
Point Charts
-
Polar and Radar Charts
-
Range Charts
- Sankey Chart
-
Sparkline Charts
-
Tree Map
-
Gauges
- Overview
-
Runtime update
-
Bar Gauge
-
Circular Gauge
-
Linear Gauge
-
Diagram
- Overview
-
Data Binding
-
Featured Shapes
-
Custom Shapes
-
Document Capabilities
-
User Interaction
- UI Customization
- Adaptability
-
-
Scheduling / Planning
-
Scheduler
- Overview
-
Data Binding
-
Views
-
Appointments
-
Timetable
- Editing
-
Grouping
- Virtual Scrolling
- Drag & Drop
-
Customization
- Adaptability
-
Gantt
- Overview
- Data Binding
-
Filtering
- Sorting
- Strip Lines
- Export to PDF
- Validation
-
Customization
-
-
Messaging
-
WYSIWYG Editor
-
Forms
-
Data Editors
- Overview
-
Common Concepts
-
Calendar
- Check Box
- Color Box
-
Date Box
-
Date Range Box
-
Number Box
- Radio Group
-
Range Selector
- Range Slider
- Slider
- Switch
- Text Area
- Text Box
-
Drop-Downs
- Autocomplete
-
Drop Down Box
-
Select Box
-
Tag Box
-
Lookup
-
Buttons
-
File Upload / File Management
-
File Manager
- Overview
-
File System Types
-
Customization
-
File Uploader
-
-
Popup and Notifications
-
Navigation
- Overview
- Accordion
-
Action Sheet
-
Context Menu
-
Menu
- Multi View
-
Drawer
-
Tab Panel
-
Tabs
-
Toolbar
-
Stepper
- Pagination
-
List
-
Tree View
- Right-to-Left Support
-
Layout
-
Interactive Wrappers
-
Sortable
- Resizable
-
-
Progress Indicators
-
Maps
- Overview
-
Map
-
Vector Map
-
Data Binding
- Multiple Layers
-
Markers
- Legend
-
Zooming and Panning
-
Customization
-
-
Localization
Related Demos:
Your search did not match any results.
JavaScript/jQuery Data Editors - Custom Text Editor Buttons
Text editors have built-in action buttons that allow users to open a drop-down menu, increase, decrease, or nullify the value, and perform other actions. To add custom action buttons for different scenarios, use the buttons[] array.
The USD/EUR rate is taken from www.wikipedia.org and is relevant on 14 April 2021
Also available for:
Backend API
$(() => {
const passwordEditor = $('#password').dxTextBox({
placeholder: 'password',
mode: 'password',
value: 'password',
inputAttr: { 'aria-label': 'Password' },
stylingMode: 'filled',
buttons: [{
name: 'password',
location: 'after',
options: {
icon: 'eyeopen',
stylingMode: 'text',
onClick() {
passwordEditor.option('mode', passwordEditor.option('mode') === 'text' ? 'password' : 'text');
},
},
}],
}).dxTextBox('instance');
const currencyEditor = $('#multicurrency').dxNumberBox({
value: 14500.55,
format: '$ #.##',
showClearButton: true,
showSpinButtons: true,
inputAttr: { 'aria-label': 'Multi Currency' },
buttons: [{
name: 'currency',
location: 'after',
options: {
text: '€',
stylingMode: 'text',
width: 32,
elementAttr: {
class: 'currency',
},
onClick(e) {
if (e.component.option('text') === '$') {
e.component.option('text', '€');
currencyEditor.option('format', '$ #.##');
currencyEditor.option('value', currencyEditor.option('value') / 0.836);
} else {
e.component.option('text', '$');
currencyEditor.option('format', '€ #.##');
currencyEditor.option('value', currencyEditor.option('value') * 0.836);
}
},
},
}, 'clear', 'spins'],
}).dxNumberBox('instance');
const millisecondsInDay = 24 * 60 * 60 * 1000;
const dateEditor = $('#advanced-datebox').dxDateBox({
value: new Date().getTime(),
stylingMode: 'outlined',
inputAttr: { 'aria-label': 'Date' },
buttons: [{
name: 'today',
location: 'before',
options: {
text: 'Today',
stylingMode: 'text',
onClick() {
dateEditor.option('value', new Date().getTime());
},
},
}, {
name: 'prevDate',
location: 'before',
options: {
icon: 'spinprev',
stylingMode: 'text',
onClick() {
const currentDate = dateEditor.option('value');
dateEditor.option('value', currentDate - millisecondsInDay);
},
},
}, {
name: 'nextDate',
location: 'after',
options: {
icon: 'spinnext',
stylingMode: 'text',
onClick() {
const currentDate = dateEditor.option('value');
dateEditor.option('value', currentDate + millisecondsInDay);
},
},
}, 'dropDown'],
}).dxDateBox('instance');
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<script src="js/dx.all.js?v=26.1.4"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="index.js"></script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div class="dx-fieldset">
<div class="dx-field">
<div class="dx-field-label">Password TextBox</div>
<div class="dx-field-value">
<div id="password"></div>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Multi-currency NumberBox</div>
<div class="dx-field-value">
<div id="multicurrency"></div>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Advanced DateBox</div>
<div class="dx-field-value">
<div id="advanced-datebox"></div>
</div>
</div>
</div>
</div>
</body>
</html>
.dx-fieldset {
min-height: 560px;
width: 560px;
margin: 0 auto;
}
.currency {
min-width: 32px;
}
.dx-button.currency .dx-button-content {
font-size: 120%;
padding-left: 5px;
padding-right: 5px;
}
Each object in the buttons[] array should have the name field—the button's identifier. In addition, specify the button's location relative to the input text field and options of the Button component used as the action button.
The buttons[] array also accepts string values—the names of built-in buttons. Declare them in the order the buttons should have in the component. String and object declarations can be used in the same array.

Backend API
<template>
<div>
<div class="dx-fieldset">
<div class="dx-field">
<div class="dx-field-label">Password TextBox</div>
<div class="dx-field-value">
<DxTextBox
v-model:mode="passwordMode"
value="password"
:input-attr="{ 'aria-label': 'Password' }"
styling-mode="filled"
placeholder="password"
>
<DxTextBoxButton
:options="passwordButton"
name="password"
location="after"
/>
</DxTextBox>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Multi-currency NumberBox</div>
<div class="dx-field-value">
<DxNumberBox
v-model:value="currencyValue"
:format="currencyFormat"
:show-clear-button="true"
:show-spin-buttons="true"
:input-attr="{ 'aria-label': 'Currency Value' }"
>
<DxNumberBoxButton
:options="currencyButton"
name="currency"
location="after"
/>
<DxNumberBoxButton name="clear"/>
<DxNumberBoxButton name="spins"/>
</DxNumberBox>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Advanced DateBox</div>
<div class="dx-field-value">
<DxDateBox
v-model:value="dateValue"
:input-attr="{ 'aria-label': 'Date' }"
styling-mode="outlined"
>
<DxDateBoxButton
:options="todayButton"
name="today"
location="before"
/>
<DxDateBoxButton
:options="prevDateButton"
name="prevDate"
location="before"
/>
<DxDateBoxButton
:options="nextDateButton"
name="nextDate"
location="after"
/>
<DxDateBoxButton name="dropDown"/>
</DxDateBox>
</div>
</div>
</div>
</div>
</template>
<script setup lang="ts">
import { ref } from 'vue';
import { DxTextBox, DxButton as DxTextBoxButton, type DxTextBoxTypes } from 'devextreme-vue/text-box';
import { DxNumberBox, DxButton as DxNumberBoxButton } from 'devextreme-vue/number-box';
import { DxDateBox, DxButton as DxDateBoxButton } from 'devextreme-vue/date-box';
import { type DxButtonTypes } from 'devextreme-vue/button';
const millisecondsInDay = 24 * 60 * 60 * 1000;
const passwordMode = ref<DxTextBoxTypes.TextBoxType>('password');
const passwordButton = {
icon: 'eyeopen',
stylingMode: 'text',
onClick: () => {
passwordMode.value = passwordMode.value === 'text' ? 'password' : 'text';
},
};
const currencyFormat = ref('$ #.##');
const currencyValue = ref(14500.55);
const currencyButton = {
text: '€',
stylingMode: 'text',
width: 32,
elementAttr: {
class: 'currency',
},
onClick: (e: DxButtonTypes.ClickEvent) => {
if (e.component.option('text') === '$') {
e.component.option('text', '€');
currencyFormat.value = '$ #.##';
currencyValue.value /= 0.836;
} else {
e.component.option('text', '$');
currencyFormat.value = '€ #.##';
currencyValue.value *= 0.836;
}
},
};
const dateValue = ref(new Date().getTime());
const todayButton = {
text: 'Today',
stylingMode: 'text',
onClick: () => {
dateValue.value = new Date().getTime();
},
};
const prevDateButton = {
icon: 'spinprev',
stylingMode: 'text',
onClick: () => {
dateValue.value -= millisecondsInDay;
},
};
const nextDateButton = {
icon: 'spinnext',
stylingMode: 'text',
onClick: () => {
dateValue.value += millisecondsInDay;
},
};
</script>
<style>
.dx-fieldset {
min-height: 560px;
width: 560px;
margin: 0 auto;
}
.currency {
min-width: 32px;
}
.dx-button.currency .dx-button-content {
font-size: 120%;
padding-left: 5px;
padding-right: 5px;
}
</style>
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'typescript': {
'exports': 'ts',
},
'vue': {
format: 'global',
exports: 'Vue',
esModule: true,
},
'vuex': {
format: 'global',
exports: 'Vuex',
esModule: true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'vue': 'npm:vue@3.5.40/dist/vue.global.js',
'@vue/shared': 'npm:@vue/shared@3.4.26/dist/shared.cjs.prod.js',
'dx-systemjs-vue-browser': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'vue-loader': 'loaders:demo-vue-loader.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.4/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>
Each object in the buttons[] array should have the name field—the button's identifier. In addition, specify the button's location relative to the input text field and options of the Button component used as the action button.
The buttons[] array also accepts string values—the names of built-in buttons. Declare them in the order the buttons should have in the component. String and object declarations can be used in the same array.

Backend API
import React, { useCallback, useMemo, useState } from 'react';
import { TextBox, Button as TextBoxButton } from 'devextreme-react/text-box';
import type { TextBoxTypes } from 'devextreme-react/text-box';
import { NumberBox, Button as NumberBoxButton } from 'devextreme-react/number-box';
import type { NumberBoxTypes } from 'devextreme-react/number-box';
import { DateBox, Button as DateBoxButton } from 'devextreme-react/date-box';
import type { DateBoxTypes } from 'devextreme-react/date-box';
import type { ButtonTypes } from 'devextreme-react/button';
const millisecondsInDay = 24 * 60 * 60 * 1000;
const currencyLabel = { 'aria-label': 'Multi Currency' };
const dateBoxLabel = { 'aria-label': 'Date' };
const passwordLabel = { 'aria-label': 'Password' };
function App() {
const [passwordMode, setPasswordMode] = useState<TextBoxTypes.TextBoxType>('password');
const [currencyFormat, setCurrencyFormat] = useState<string>('$ #.##');
const [currencyValue, setCurrencyValue] = useState<number>(14500.55);
const [dateValue, setDateValue] = useState<number>(new Date().getTime());
const passwordButton = useMemo<ButtonTypes.Properties>(
(): ButtonTypes.Properties => ({
icon: 'eyeopen',
stylingMode: 'text',
onClick: (): void => {
setPasswordMode((prevPasswordMode: string) =>
(prevPasswordMode === 'text' ? 'password' : 'text'));
},
}),
[],
);
const currencyButton = useMemo<ButtonTypes.Properties>(
(): ButtonTypes.Properties => ({
text: '€',
stylingMode: 'text',
width: 32,
elementAttr: {
class: 'currency',
},
onClick: (e: ButtonTypes.ClickEvent): void => {
if (e.component.option('text') === '$') {
e.component.option('text', '€');
setCurrencyFormat('$ #.##');
setCurrencyValue((prevCurrencyValue: number): number => prevCurrencyValue / 0.836);
} else {
e.component.option('text', '$');
setCurrencyFormat('€ #.##');
setCurrencyValue((prevCurrencyValue: number): number => prevCurrencyValue * 0.836);
}
},
}),
[],
);
const todayButton = useMemo<ButtonTypes.Properties>(
(): ButtonTypes.Properties => ({
text: 'Today',
stylingMode: 'text',
onClick: (): void => {
setDateValue(new Date().getTime());
},
}),
[],
);
const prevDateButton = useMemo<ButtonTypes.Properties>(
(): ButtonTypes.Properties => ({
icon: 'spinprev',
stylingMode: 'text',
onClick: (): void => {
setDateValue((prevDateValue: number): number => prevDateValue - millisecondsInDay);
},
}),
[],
);
const nextDateButton = useMemo<ButtonTypes.Properties>(
(): ButtonTypes.Properties => ({
icon: 'spinnext',
stylingMode: 'text',
onClick: (): void => {
setDateValue((prevDateValue: number): number => prevDateValue + millisecondsInDay);
},
}),
[],
);
const onDateChanged = useCallback(
(e: DateBoxTypes.ValueChangedEvent): void => {
setDateValue(e.value);
},
[],
);
const changeCurrency = useCallback(
(data: NumberBoxTypes.ValueChangedEvent): void => {
setCurrencyValue(data.value);
},
[],
);
return (
<>
<div className="dx-fieldset">
<div className="dx-field">
<div className="dx-field-label">Password TextBox</div>
<div className="dx-field-value">
<TextBox
placeholder="password"
stylingMode="filled"
defaultValue="password"
inputAttr={passwordLabel}
mode={passwordMode}
>
<TextBoxButton
name="password"
location="after"
options={passwordButton}
/>
</TextBox>
</div>
</div>
<div className="dx-field">
<div className="dx-field-label">Multi-currency NumberBox</div>
<div className="dx-field-value">
<NumberBox
showClearButton={true}
showSpinButtons={true}
format={currencyFormat}
value={currencyValue}
inputAttr={currencyLabel}
onValueChanged={changeCurrency}
>
<NumberBoxButton
name="currency"
location="after"
options={currencyButton}
/>
<NumberBoxButton name="clear" />
<NumberBoxButton name="spins" />
</NumberBox>
</div>
</div>
<div className="dx-field">
<div className="dx-field-label">Advanced DateBox</div>
<div className="dx-field-value">
<DateBox
value={dateValue}
stylingMode="outlined"
inputAttr={dateBoxLabel}
onValueChanged={onDateChanged}
>
<DateBoxButton
name="today"
location="before"
options={todayButton}
/>
<DateBoxButton
name="prevDate"
location="before"
options={prevDateButton}
/>
<DateBoxButton
name="nextDate"
location="after"
options={nextDateButton}
/>
<DateBoxButton name="dropDown" />
</DateBox>
</div>
</div>
</div>
</>
);
}
export default App;
import React, { useCallback, useMemo, useState } from 'react';
import { TextBox, Button as TextBoxButton } from 'devextreme-react/text-box';
import { NumberBox, Button as NumberBoxButton } from 'devextreme-react/number-box';
import { DateBox, Button as DateBoxButton } from 'devextreme-react/date-box';
const millisecondsInDay = 24 * 60 * 60 * 1000;
const currencyLabel = { 'aria-label': 'Multi Currency' };
const dateBoxLabel = { 'aria-label': 'Date' };
const passwordLabel = { 'aria-label': 'Password' };
function App() {
const [passwordMode, setPasswordMode] = useState('password');
const [currencyFormat, setCurrencyFormat] = useState('$ #.##');
const [currencyValue, setCurrencyValue] = useState(14500.55);
const [dateValue, setDateValue] = useState(new Date().getTime());
const passwordButton = useMemo(
() => ({
icon: 'eyeopen',
stylingMode: 'text',
onClick: () => {
setPasswordMode((prevPasswordMode) => (prevPasswordMode === 'text' ? 'password' : 'text'));
},
}),
[],
);
const currencyButton = useMemo(
() => ({
text: '€',
stylingMode: 'text',
width: 32,
elementAttr: {
class: 'currency',
},
onClick: (e) => {
if (e.component.option('text') === '$') {
e.component.option('text', '€');
setCurrencyFormat('$ #.##');
setCurrencyValue((prevCurrencyValue) => prevCurrencyValue / 0.836);
} else {
e.component.option('text', '$');
setCurrencyFormat('€ #.##');
setCurrencyValue((prevCurrencyValue) => prevCurrencyValue * 0.836);
}
},
}),
[],
);
const todayButton = useMemo(
() => ({
text: 'Today',
stylingMode: 'text',
onClick: () => {
setDateValue(new Date().getTime());
},
}),
[],
);
const prevDateButton = useMemo(
() => ({
icon: 'spinprev',
stylingMode: 'text',
onClick: () => {
setDateValue((prevDateValue) => prevDateValue - millisecondsInDay);
},
}),
[],
);
const nextDateButton = useMemo(
() => ({
icon: 'spinnext',
stylingMode: 'text',
onClick: () => {
setDateValue((prevDateValue) => prevDateValue + millisecondsInDay);
},
}),
[],
);
const onDateChanged = useCallback((e) => {
setDateValue(e.value);
}, []);
const changeCurrency = useCallback((data) => {
setCurrencyValue(data.value);
}, []);
return (
<>
<div className="dx-fieldset">
<div className="dx-field">
<div className="dx-field-label">Password TextBox</div>
<div className="dx-field-value">
<TextBox
placeholder="password"
stylingMode="filled"
defaultValue="password"
inputAttr={passwordLabel}
mode={passwordMode}
>
<TextBoxButton
name="password"
location="after"
options={passwordButton}
/>
</TextBox>
</div>
</div>
<div className="dx-field">
<div className="dx-field-label">Multi-currency NumberBox</div>
<div className="dx-field-value">
<NumberBox
showClearButton={true}
showSpinButtons={true}
format={currencyFormat}
value={currencyValue}
inputAttr={currencyLabel}
onValueChanged={changeCurrency}
>
<NumberBoxButton
name="currency"
location="after"
options={currencyButton}
/>
<NumberBoxButton name="clear" />
<NumberBoxButton name="spins" />
</NumberBox>
</div>
</div>
<div className="dx-field">
<div className="dx-field-label">Advanced DateBox</div>
<div className="dx-field-value">
<DateBox
value={dateValue}
stylingMode="outlined"
inputAttr={dateBoxLabel}
onValueChanged={onDateChanged}
>
<DateBoxButton
name="today"
location="before"
options={todayButton}
/>
<DateBoxButton
name="prevDate"
location="before"
options={prevDateButton}
/>
<DateBoxButton
name="nextDate"
location="after"
options={nextDateButton}
/>
<DateBoxButton name="dropDown" />
</DateBox>
</div>
</div>
</div>
</>
);
}
export default App;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(<App />, document.getElementById('app'));
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'*.tsx': {
loader: 'demo-ts-loader',
typescriptOptions: {
jsx: 'react',
},
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'react': {
'esModule': true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
defaultExtension: 'js',
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
.dx-fieldset {
min-height: 560px;
width: 560px;
margin: 0 auto;
}
.currency {
min-width: 32px;
}
.dx-button.currency .dx-button-content {
font-size: 120%;
padding-left: 5px;
padding-right: 5px;
}
Each object in the buttons[] array should have the name field—the button's identifier. In addition, specify the button's location relative to the input text field and options of the Button component used as the action button.
The buttons[] array also accepts string values—the names of built-in buttons. Declare them in the order the buttons should have in the component. String and object declarations can be used in the same array.

Backend API
<div class="dx-fieldset">
<div class="dx-field">
<div class="dx-field-label">Password TextBox</div>
<div class="dx-field-value">
<dx-text-box
value="password"
placeholder="password"
[inputAttr]="{ 'aria-label': 'Password' }"
stylingMode="filled"
[(mode)]="passwordMode"
>
<dxi-text-box-button
name="today"
location="after"
[options]="passwordButton"
></dxi-text-box-button>
</dx-text-box>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Multi-currency NumberBox</div>
<div class="dx-field-value">
<dx-number-box
[value]="14500.55"
[(format)]="currencyFormat"
[showClearButton]="true"
[showSpinButtons]="true"
[inputAttr]="{ 'aria-label': 'Currency Format' }"
>
<dxi-number-box-button
name="currency"
location="after"
[options]="currencyButton"
></dxi-number-box-button>
<dxi-number-box-button name="clear"></dxi-number-box-button>
<dxi-number-box-button name="spins"></dxi-number-box-button>
</dx-number-box>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Advanced DateBox</div>
<div class="dx-field-value">
<dx-date-box
stylingMode="outlined"
[(value)]="dateValue"
[inputAttr]="{ 'aria-label': 'Date' }"
>
<dxi-date-box-button
name="today"
location="before"
[options]="todayButton"
></dxi-date-box-button>
<dxi-date-box-button
name="prevDate"
location="before"
[options]="prevDateButton"
></dxi-date-box-button>
<dxi-date-box-button
name="nextDate"
location="after"
[options]="nextDateButton"
></dxi-date-box-button>
<dxi-date-box-button name="dropDown"></dxi-date-box-button>
</dx-date-box>
</div>
</div>
</div>
import { bootstrapApplication } from '@angular/platform-browser';
import { enableProdMode, Component, provideZoneChangeDetection } from '@angular/core';
import { DxNumberBoxModule, DxDateBoxModule } from 'devextreme-angular';
import { DxButtonTypes } from 'devextreme-angular/ui/button';
import { DxTextBoxModule, DxTextBoxTypes } from 'devextreme-angular/ui/text-box';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
providers: [],
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
preserveWhitespaces: true,
imports: [
DxTextBoxModule,
DxNumberBoxModule,
DxDateBoxModule,
],
})
export class AppComponent {
millisecondsInDay = 24 * 60 * 60 * 1000;
currencyFormat = '$ #.##';
priceValue = 14500.55;
passwordMode: DxTextBoxTypes.TextBoxType = 'password';
dateValue = new Date().getTime();
passwordButton: DxButtonTypes.Properties = {
icon: 'eyeopen',
stylingMode: 'text',
onClick: () => {
this.passwordMode = this.passwordMode === 'text' ? 'password' : 'text';
},
};
currencyButton: DxButtonTypes.Properties = {
text: '€',
stylingMode: 'text',
width: 32,
elementAttr: {
class: 'currency',
},
onClick: (e) => {
if (e.component.option('text') === '$') {
e.component.option('text', '€');
this.currencyFormat = '$ #.##';
this.priceValue /= 0.836;
} else {
e.component.option('text', '$');
this.currencyFormat = '€ #.##';
this.priceValue *= 0.836;
}
},
};
todayButton: DxButtonTypes.Properties = {
text: 'Today',
stylingMode: 'text',
onClick: () => {
this.dateValue = new Date().getTime();
},
};
prevDateButton: DxButtonTypes.Properties = {
icon: 'spinprev',
stylingMode: 'text',
onClick: () => {
this.dateValue -= this.millisecondsInDay;
},
};
nextDateButton: DxButtonTypes.Properties = {
icon: 'spinnext',
stylingMode: 'text',
onClick: () => {
this.dateValue += this.millisecondsInDay;
},
};
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
],
});
::ng-deep .dx-fieldset {
min-height: 560px;
width: 560px;
margin: 0 auto;
}
::ng-deep .currency {
min-width: 32px;
}
::ng-deep .dx-button.currency .dx-button-content {
font-size: 120%;
padding-left: 5px;
padding-right: 5px;
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.4/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.16.2/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.29/package.json',
'npm:devexpress-gantt@4.1.69/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
},
"@angular/core": {
"version": "22.1.0"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "6.0.3"
},
"zone.js": {
"version": "0.16.2"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.16.2/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>
Each object in the buttons[] array should have the name field—the button's identifier. In addition, specify the button's location relative to the input text field and options of the Button component used as the action button.
The buttons[] array also accepts string values—the names of built-in buttons. Declare them in the order the buttons should have in the component. String and object declarations can be used in the same array.